#!/bin/bash

nlvm="/sbin/nlvm"
echo $nlvm
if [ -f $nlvm ];
then
   echo "This is probably an OES server !"
   echo "Continue with unmounting pools and volumes"
else
   echo "This is probably NOT an OES server !"
   echo "The required tool $nlvm does not exist"
   echo "Cancel unmounting pools and volumes"
   exit
fi

# Sesam Umgebung setzen
source `/usr/bin/grep -i '^sm_ini=' /etc/sesam2000.ini|/usr/bin/cut -d"=" -f2` 2>/dev/null
source "${gv_rw_ini}/sesam2000.profile" >/dev/null 2>&1

# READ INI
read_ini()
{
  SM_INI=`/usr/bin/grep -i '^sm_ini=' /etc/sesam2000.ini|/usr/bin/cut -d '=' -f2`
  echo `/usr/bin/grep -i "$1=" "$SM_INI"|/usr/bin/cut -d"=" -f2`
}




# variables
count=1
p=p
hk="'"
actdate=`date +%Y-%m-%d`
acttime=`date +%`
GV_RW_TMP=`read_ini gv_rw_tmp`
tpath="/usr/bin"
cpath="/bin"
npath="/sbin"
mpath="/media/nss"
ppath="/dev/pool"

while read line; 
do
   pstate=$($npath/nlvm -m list pool $line | $tpath/sed -n 2p | $tpath/cut -d "=" -f 2 | $tpath/cut -d " " -f 1)
  if [[ $pstate == "NotMounted" ]]
  then
     $npath/nlvm -m mount $line ;
  fi
  echo "Deactivating pool $line "
  $npath/nlvm -m pool deactivate $line ;
done < $GV_RW_TMP'act_pools'

while read line;
do
   echo "Unmounting volume $line "
   $npath/nlvm volume unmount $line
done < $GV_RW_TMP'act_vols'

while read line;
do
   echo "Unmounting pool $line via umount "
   umount  $ppath/$line ;
done < $GV_RW_TMP'act_pools'


# restore original /etc/fstab and /etc/mtab because nlvm adds entries automatically
$cpath/cp $GV_RW_TMP'fstab_org' /etc/fstab

# removing temporary files
$cpath/rm $GV_RW_TMP'fstab_org'
$cpath/rm $GV_RW_TMP'act_pools'
$cpath/rm $GV_RW_TMP'act_vols'
$cpath/mount -a
$npath/nlvm -m -r

$cpath/echo "*****************************************"
$cpath/echo 
$cpath/echo "status of / available Volumes after unmounting :"
$npath/nlvm -m list volumes
$cpath/echo 
$cpath/echo "*****************************************"
$cpath/echo 
$cpath/echo "status of NSS Pools after deactivating:"
$npath/nlvm -m list pools
$cpath/echo 
$cpath/echo "*****************************************"
$cpath/echo 
$cpath/echo " END OF POST SCRIPT FOR NSS POOLS AND VOLUMES "
$cpath/echo
exit
