@echo off

REM $Id: sm_execute_update.cmd,v 1.13 2013/07/12 07:57:09 kha Exp $

setlocal EnableDelayedExpansion
set pwd=
set pwdDrive=

for /R %%a in (sm_setup.exe) do (
   set pwd=%%~dpa
   set pwdDrive=%%~da
)
set workpath=
for /F "usebackq tokens=1,2,3 delims==" %%a in (`sm_setup get_reg "HKLM\SOFTWARE\SEP Elektronik GmbH\sesam" SM_INI`) do (
   set workpath=%%c
   set logPath=!workpath:ini\sm.ini=log\lgc!
   set workpath=!workpath:ini\sm.ini=work\!
)

REM move the old sm_ctrld.exe which is in use to bin directory to make sure that also a major update works
set sm_ctrld_old=%pwd%..\sm_ctrld_old.exe
if exist "%pwd%sm_ctrld.exe" move /Y "%pwd%sm_ctrld.exe" "%sm_ctrld_old%" >"%temp%\tmp.log"
if exist "%sm_ctrld_old%" copy /Y "%sm_ctrld_old%" "%pwd%sm_ctrld.exe" >"%temp%\tmp.log"
REM move the old sm_sshd.exe which is in use to bin directory to make sure that also a major update works
set sm_sshd_old=%pwd%..\sm_sshd_old.exe
if exist "%pwd%sm_sshd.exe" move /Y "%pwd%sm_sshd.exe" "%sm_sshd_old%" >"%temp%\tmp.log"
if exist "%sm_sshd_old%" copy /Y "%sm_sshd_old%" "%pwd%sm_sshd.exe" >"%temp%\tmp.log"

REM Write output to logfile
if exist "%logPath%\sm_execute_update.lgc" (
   for /F "tokens=1,2 delims=: " %%a in ('time /T') do (
      move /Y "%logPath%\sm_execute_update.lgc" "%logPath%\sm_execute_update_%%a%%b.lgc" >"%temp%\tmp.log"
   )
)
set logFilename="%logPath%\sm_execute_update.lgc"
call :trace " "
call :trace "Starting the update process"

set filename=
if "%1" EQU "-v" (
   set verbose=%2
) else (
   set filename=%1
   if "%2" EQU "-v" (
         set verbose=%3
      )
   )
)
if "%verbose%" EQU "2" (
   @echo on
)

set drive=
set filepath=
if "%verbose%" GEQ "1" call :trace "pwd=%pwd%"
if not defined filename (
   for /F "usebackq tokens=1 delims=" %%x in (`dir /b "%workpath%sesam-*-*-windows*.exe"`) do (
      set filename=%%x
      set filepath=%workpath%
   )
   if "%verbose%" GEQ "1" call :trace "Obtained filename '%workpath%!filename!' from work directory default"
) else (
   if not exist "%filename%" (
      if not exist "%workpath%%filename%" (
         for /F "usebackq tokens=1 delims=" %%x in (`dir /b "%workpath%sesam-*-*-windows*.exe"`) do (
            set filename=%%x
            set filepath=%workpath%
         )
         if "%verbose%" GEQ "1" call :trace "Obtained filename '%workpath%!filename!' from work directory default"
      ) else (
         if "%verbose%" GEQ "1" call :trace "Obtained filename '%workpath%%filename%' from cmd line"
      )
   ) else (
      if "%verbose%" GEQ "1" call :trace "Obtained filename '%filename%' from cmd line"
   )
)

if exist "%workpath%%filename%" (
   for %%a in ("%workpath%%filename%") do (
      set drive=%%~da
      set filepath=%%~dpa
      set filename=%%~na.exe
      if "%verbose%" GEQ "1" call :trace "Found drive '!drive!', filepath '!filepath!' and filename '!filename!'"
   )
) else (
   if exist "%filename%" (
      for %%a in ("%filename%") do (
         set drive=%%~da
         set filepath=%%~dpa
         set filename=%%~na.exe
         if "%verbose%" GEQ "1" call :trace "Found drive '!drive!', filepath '!filepath!' and filename '!filename!'"
      )
   ) else (
      call :trace "No filename given and no sesam-*-*-windows*.exe file found in %workpath% directory default"
      call :trace " "
      call :trace "For verbose level insert '-v 1' as second parameter"
      call :trace "e.g. sm_execute_update.cmd sesam_cli_4.0.6.1_windows_x86.exe -v 1"
      call :trace "The file '%filepath%%filename%' could not be found"
      call :trace " "
      call :trace "If the file is located on a network drive remember to connect the network drive before executing this batch file. This can be done using e.g."
      call :trace " "
      call :trace "'at [time] /INTERACTIVE cmd.exe'"
      call :trace " "
      call :trace "followed by"
      call :trace " "
      call :trace "'net USE Z: \\informatix\Share /USER:admin'"
      call :trace " "
      call :trace "which has to be inserted in the newly opened cmd box"
      call :trace " "
      
      call :trace "STATUS=ERROR MSG=No filename given and no sesam-*-*-windows*.exe file found in %workpath%" 2
      EXIT /b 1
   )
)

set newversion=
for /F "tokens=1,2,3,4,5 delims=-." %%a in ("%filename%") do (
   set newversion=%%c.%%d.%%e
)
if "%verbose%" GEQ "1" call :trace "Obtained new major version number '%newversion%'"

set regkey=
if exist "%logPath%\sm_msi.lgc" (
   for /F "tokens=1,2 delims=: " %%a in ('time /T') do (
      move /Y "%logPath%\sm_msi.lgc" "%logPath%\sm_msi_%%a%%b.lgc" >"%temp%\tmp.log"
   )
)
set msiexitcode=
if defined newversion (
   for /F "tokens=1,2" %%a in ('sm_setup get_reg HKLM\SOFTWARE\Classes\Installer\Products') do (
      set regkey=%%b
      set foundReg=
      if "!regkey:~0,-16!" EQU "7737007073521AA4" (
         set foundReg=1
      )	
      if "!foundReg!" EQU "1" (
         set regkey=HKLM\SOFTWARE\Classes\Installer\Products\!regkey!\SourceList
         if "%verbose%" GEQ "1" call :trace "Found sesam registry key !regkey!"
         if "%verbose%" GEQ "1" call :trace "calling 'sm_setup get_reg !regkey! PackageName'"
         if "%verbose%" GEQ "1" sm_setup get_reg !regkey! PackageName >> %logFilename%
         for /f "tokens=3,4,5 delims=-." %%k in ('sm_setup get_reg !regkey! PackageName') do (    
            set oldversion=%%k.%%l.%%m
            call :trace "Obtained old major version number '!oldversion!'"

            %drive% >> %logFilename%
            if "%verbose%" GEQ "1" call :trace "cd %filepath%"
            cd %filepath% >> %logFilename%

            if "%newversion%" EQU "!oldversion!" (
               call :trace "Major version number did not change since last update"
               call :trace "Executing ' start /wait %filename% /s /v''/qn /norestart /lvoicewarmup \''%logPath%\sm_msi.lgc\'' REINSTALL=ALL'' '"
               start /wait %filename% /s /v"/qn /norestart /lvoicewarmup \"%logPath%\sm_msi.lgc\" REINSTALL=ALL"
               set msiexitcode=!errorlevel!
               call :trace "returned !msiexitcode!"
            ) else (
               if "%newversion%" GTR "!oldversion!" (
                  call :trace "Major version number changed since last update"
                  call :trace "Executing ' start /wait %filename% /s /v''/qn /norestart /lvoicewarmup \''%logPath%\sm_msi.lgc\'' '"
                  start /wait %filename% /s /v"/qn /norestart /lvoicewarmup \"%logPath%\sm_msi.lgc\""
                  set msiexitcode=!errorlevel!
                  call :trace "returned !msiexitcode!"
               )
            )

            %pwdDrive% >> %logFilename%
            if "%verbose%" GEQ "1" call :trace "cd %pwd%"
            cd %pwd% >> %logFilename%
         )
      )
   )
) else (
   call :trace "STATUS=ERROR MSG=The new version number could not be extracted from the filename" 2
   EXIT /b 1
)
REM move old sm_ctrld.exe back into the bin\sesam directory if it can not be deleted
if exist "%sm_ctrld_old%" move /Y "%sm_ctrld_old%" "%pwd%sm_ctrld_old.exe" >"%temp%\tmp.log"
REM move old sm_sshd.exe back into the bin\sesam directory if it can not be deleted
if exist "%sm_sshd_old%" move /Y "%sm_sshd_old%" "%pwd%sm_sshd_old.exe" >"%temp%\tmp.log"

if "%msiexitcode%" NEQ "0" (
   call :trace "STATUS=ERROR MSG=An error occured during update. See %logPath%\sm_msi.lgc, %logPath%\sm_setup_msi.lgc, and %logPath%\sm_setup.lgc for further details; returned %msiexitcode%" 2
   EXIT /b %msiexitcode%
) else (
   call :trace "STATUS=SUCCESS MSG=The update was successful; returned %msiexitcode%" 2
   EXIT /b %msiexitcode%
)

GOTO:EOF

:trace
set string=
set string=%1
set string=%string:"=%

if "%string%" EQU " " (
   set string=echo.
) else (
   set string=echo %string%
)

if "%2" NEQ "" (
   %string%
) else (
   %string% 1>&2
)
%string% >> %logFilename% 2>&1

EXIT /b 0
